<?php
/*
     This file is an extension of the original SearchMySQLwildcards.php in "Extension:Wildcard Search".
     Modified since 2007/11/08.
     For the original source, see at http://www.mediawiki.org/wiki/Extension:Wildcard_search.

     *********************************************************************

     MySQLLikeSearch.php Mediawiki extension. 	Modification of left slot
      search functioun, can use '%' and '_' as wild-card which 'like' operator.
     See detail http://metabolomics.jp/wiki/Help:Extension/MySQLLikeSearch
     Last-modified: 2010.02.10
     Version: 0.11
     Change:
       - Change require path to fit 1.16.2

     History
     Version: 0.1 2008.09.17

     *********************************************************************

     Copyright (C) 2008 Metabolomics.JP Development Team

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

     *********************************************************************
     Author: Arita laboratory, with Kazuhiro Suwa <metabolome@cb.k.u-tokyo.ac.jp>
     URL: http://metabolomics.jp/
*/

if( !defined( 'MEDIAWIKI' ) ){
	die( 'This file is a MediaWiki extension, see <a href="http://metabolomics.jp/wiki/Help:Extension/MySQLLikeSearch>MySQLLikeSearch.php</a>.' );
}

require_once( 'includes/search/SearchEngine.php' );
require_once( 'includes/search/SearchMySQL.php' );
require_once( 'includes/search/SearchMySQL4.php' );
 
$wgSearchType   = 'MySQLLikeSearch';
#$strictMatching = false;
 
$wgExtensionCredits['other'][] = array(
	'name' => 'MySQLLikeSearch',
	'version' => '0.11',
	'author' => 'K, Suwa<br>Original Source - Assela Pathirana',
	'description' => 'Modification of left slot search functioun, can use \'%\' and \'_\' as wild-card which \'like\' operator',
	'url' => 'http://metabolomics.jp/wiki/Help:Extension/MySQLLikeSearch',
);

class MySQLLikeSearch extends SearchMySQL4 {
	public static function legalSearchChars() {
		return "A-Za-z'0-9\\x80-\\xFF\\-&#_%";
	}

	function searchTitle( $term ) {
		global $wgDBprefix;

		# for search word
		$match = $this->parseQuery( $this->filter( $term ), false );

		$term = $this->encodeTerm( $term );
		if( $term == FALSE )
			return null;

		$resultSet = $this->db->resultObject( $this->db->query( 
			"select page_id, page_namespace, page_title from " . $wgDBprefix . "page, " . $wgDBprefix . "searchindex 
				where si_page = page_id and si_title like '%$term%' " . 
			$this->queryRedirect() . " " . 
			$this->queryNamespaces() . 
			" order by page_id " . 
			$this->queryLimit() ) );

		return new MySQLSearchResultSet( $resultSet, $this->searchTerms );
	}

	function searchText( $term ) {
		global $wgDBprefix;

		$term = $this->encodeTerm( $term );
		if( $term == FALSE )
			return null;

		$resultSet = $this->db->resultObject( $this->db->query( 
			"select page_id, page_namespace, page_title from " . $wgDBprefix . "page, " . $wgDBprefix . "searchindex 
				where si_page = page_id and si_text like '%$term%' " . 
			$this->queryRedirect() . " " . 
			$this->queryNamespaces() . 
			" order by page_id " . 
			$this->queryLimit() ) );

		return new MySQLSearchResultSet( $resultSet, $this->searchTerms );
	}

	function encodeTerm( $term ) {
		$term = $this->filter( $term );
		# japanese translate to UTF-8
		if( function_exists( 'mb_strtolower' ) ) {
			$term = preg_replace(
				"/([\\xc0-\\xff][\\x80-\\xbf]*)/e",
				"'U8' . bin2hex( \"$1\" )",
				mb_strtolower( $term ) );
		} else {
			list( , $wikiLowerChars ) = self::getCaseMaps();
			$term = preg_replace(
				"/([\\xc0-\\xff][\\x80-\\xbf]*)/e",
				"'U8' . bin2hex( strtr( \"\$1\", \$wikiLowerChars ) )",
				$term );
		}
		$term = $this->db->strencode( $term );
		$term = mysql_real_escape_string( $term );

		return $term;
	}

}
