<?php
/*
     RowJSPage Mediawiki extension. include javascript from MediaWiki namespace
     See more RowJSPage.setup.php
     See detail http://metabolomics.jp/wiki/Help:Extension/RowJSPage

     *********************************************************************

     Copyright (C) 2010 Metabolomics.JP Development Team

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

     *********************************************************************
     Author: Arita laboratory, with Kazuhiro Suwa <metabolome@cb.k.u-tokyo.ac.jp>
     URL: http://metabolomics.jp/
*/

class RowJSPage extends SpecialPage
{
	function RowJSPage() {
		SpecialPage::SpecialPage("RowJSPage");
		self::loadMessages();
	}
 
	function execute( $par ) {
		global $wgRequest, $wgOut, $wgParser, $egRowJSPagePrefix;

		# preprocess
		$wgOut->disable();
		wfResetOutputBuffers();
		header( "Content-type: text/plain; charset=utf-8" );

		# output data
		$ns   = NS_MEDIAWIKI;
		$page = $wgRequest->getText( $egRowJSPagePrefix . "page" );
		$words = array();
		for( $i = 1; ; $i ++ ){
			$word = $wgRequest->getText( $egRowJSPagePrefix . $i );
			if( strlen( $word ) == 0 )
				break;
			$word = preg_replace( "/[^a-zA-Z0-9 _]/", "", $word );
			$words[] = $word;
		}
		if( strlen( $page ) > 0 ){
			$title = Title::makeTitleSafe( $ns, $page );
			$article = new Article( $title );
			if( $article->exists() ){
				$text = $article->getContent();
				for( $i = 1; $i <= count( $words ); $i ++ ){
					$text = preg_replace( "/\{\{\{$i\}\}\}/", $words[$i-1], $text );
				}
				print $text;
			}
		}
	}

	function loadMessages() {
		static $messagesLoaded = false;
		global $wgMessageCache;
		if ( !$messagesLoaded ) {
			$messagesLoaded = true;
 
			require( dirname( __FILE__ ) . '/RowJSPage.i18n.php' );
			foreach ( $allMessages as $lang => $langMessages ) {
				$wgMessageCache->addMessages( $langMessages, $lang );
			}
		}
		return true;
	}
}

