<?php
/*
     Volatile.php Mediawiki extension. Link and page which receive arguments.
     See detail http://metabolomics.jp/wiki/Help:Extension/Volatile
     Last-modified: 2009.03.21
     Version: 0.12
     Change:
       - fix a bug that volatile arguments is handled as php variables.

     Version: 0.11 2008.10.23
     Change:
       - case-insensitive to 'Volatile' string

     History
     Version: 0.1 2008.09.17

     *********************************************************************

     Copyright (C) 2008-2010 Metabolomics.JP Development Team

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

     *********************************************************************
     Author: Arita laboratory, with Kazuhiro Suwa <metabolome@cb.k.u-tokyo.ac.jp>
     URL: http://metabolomics.jp/
*/


if( !defined( 'MEDIAWIKI' ) ){
	die( 'This file is a MediaWiki extension, see <a href="http://metabolomics.jp/wiki/Help:Extension/Volatile">Volatile.php</a>.' );
}

$wgExtensionCredits['parserhook'][] = array(
	'name' => 'Volatile',
	'version' => '0.11',
	'author' => 'K, Suwa',
	'description' => 'Link and page which receive arguments',
	'url' => 'http://metabolomics.jp/wiki/Help:Extension/Volatile',
);

$wgHooks['ParserAfterStrip'][] = 'efVolatileReplaceArg';
$wgHooks['InternalParseBeforeLinks'][] = 'efVolatileSetLink';

function efVolatileReplaceArg( &$parser, &$text, &$strip_state ) {
	global $wgTitle;

	if( ereg( "^Volatile:.*$", $wgTitle ) ){
		$text = preg_replace( "/{{{([^}]*)}}}/", "{{#get:$1}}", $text );
	}

	return true;
}

function efVolatileSetLink( &$parser, &$text, &$strip_state ) {
	global $wgTitle, $egParamPrefix, $wgServer, $wgArticlePath;
	if( !isset( $egParamPrefix ) )
		$egParamPrefix = "my_";

	$limit = 2000;
	$i = 0;
	$str = "===volatile_variable===";
	$base = str_replace( '$1', '', $wgArticlePath );
	while( $i < $limit && preg_match( "/\[\[[ ]*Volatile:[^\]]*\]\]/i", $text, $matches, PREG_OFFSET_CAPTURE ) != 0 ){
		$text = preg_replace( "/\[\[[ ]*Volatile:[^\]]*\]\]/i", $str, $text, 1 );
		$datas = split( "\|", $matches[0][0] );
		$change = trim( $datas[0] );
		$change = preg_replace( "/^\[\[[ ]*/", "[[", $change );
		if( count( $datas ) > 1 ){
			for( $j = 1, $k = 1; $j < count( $datas ) - 1; $j ++ ){
				$datas[$j] = str_replace( "\$", "\\\$", trim( $datas[$j] ) );
				if( $j == 1 )
					$change .= "?";
				else
					$change .= "&";
				if( mb_strpos( $datas[$j], "=" ) === FALSE ){
					$change .= "$egParamPrefix$k=$datas[$j]";
					$k ++;
				} else
					$change .= "$egParamPrefix$datas[$j]";
			}
			$change .= " $datas[$j]";
		}
		$change = preg_replace( "/^\[\[/", "[$wgServer$base", $change );
		$change = preg_replace( "/\]$/", "", $change );

		$text = preg_replace( "/$str/", $change, $text, 1 );
		$i ++;
	}

	return true;
}
