<?php
/*
     ExMolFunctions.php Mediawiki extension.
     See detail http://metabolomics.jp/wiki/Help:Extension/ExMolFunctions
     Last-modified: 2009.3.14
     Version: 0.1

     *********************************************************************

     Copyright (C) 2008-2009 Metabolomics.JP Development Team

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

     *********************************************************************
     Author: Arita laboratory, with Kazuhiro Suwa <metabolome@cb.k.u-tokyo.ac.jp>
     URL: http://metabolomics.jp/
*/

$IP = "PATH_TO_WIKIROOT";
 
require( "$IP/maintenance/commandLine.inc" );

global $egMolNamespace, $wgTitle;
$egMolNamespace = "Mol";

if($argc >= 2){
	$fp = fopen( $argv[0], "r" );
	while( !feof( $fp ) ){
		$line = trim( fgets( $fp, 1024 ) );
		if( strlen( $line ) > 0 )
			efExMolFunctionsCommandLineDataInsert( trim($line) );
	}
	fclose( $fp );
}

function efExMolFunctionsCommandLineDataInsert( $title ) {
	global $wgTitle, $wgExtraNamespaces, $egMolNamespace, $egJavaBin, $egMolCalculatorJar, $egMolImageJar, $egTmpPath, $egMolPath;

	if( strncmp( $egMolNamespace, $title, 3 ) != 0 ){
		print "Invalid page name: " . $title . "\n";
		return true;
	}

	$t = Title::newFromText( $title );
	$wgTitle = $t;
	$namespace = $t->getNamespace();
	$page_title = $t->getText();

	# check namespace
	$targetNamespace = $t->getNamespace();
	$molNamespace = array_search( $egMolNamespace, $wgExtraNamespaces );
	if( $molNamespace === FALSE  || $targetNamespace != $molNamespace ){
		print "Not exists 'Mol' namespace\n";
		return true;
	}

	$article = MediaWiki::articleFromTitle( $t );
	$text = $article->getContent();
	if( $article->exists() ){
		# update database
		$article->doEdit( $text, '', EDIT_UPDATE );
	} else {
		print "There is no data: " . $t . "\n";
		return true;
	}

	print $title . " done.\n";
	return true;
}
